/*
 * fontconfig/src/fcobjshash.gperf.h
 *
 * Copyright © 2000 Keith Packard
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the author(s) not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The authors make no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE AUTHOR(S) DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE AUTHOR(S) BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */
 //+TELESCOPE_LIB_CHANGES
// 4/9/2020
// Fix bunch of issues for XBOX
 /*
%{
CUT_OUT_BEGIN
#include <fontconfig/fontconfig.h>
CUT_OUT_END
%}
*/
//-TELESCOPE_LIB_CHANGES
%struct-type
%language=ANSI-C
%includes
%enum
%readonly-tables
%define slot-name name
%define hash-function-name FcObjectTypeHash
%define lookup-function-name FcObjectTypeLookup

%pic
%define string-pool-name FcObjectTypeNamePool

struct FcObjectTypeInfo {
	int name;
	int id;
};

%%
 //+TELESCOPE_LIB_CHANGES
// 4/9/2020
// Fix bunch of issues for XBOX
"family", 1
"familylang", 2
"style", 3
"stylelang", 4
"fullname", 5
"fullnamelang", 6
"slant", 7
"weight", 8
"width", 9
"size", 10
"aspect", 11
"pixelsize", 12
"spacing", 13
"foundry", 14
"antialias", 15
"hintstyle", 16
"hinting", 17
"verticallayout", 18
"autohint", 19
"globaladvance", 20
"file", 21
"index", 22
"rasterizer", 23
"outline", 24
"scalable", 25
"dpi", 26
"rgba", 27
"scale", 28
"minspace", 29
"charwidth", 30
"charheight", 31
"matrix", 32
"charset", 33
"lang", 34
"fontversion", 35
"capability", 36
"fontformat", 37
"embolden", 38
"embeddedbitmap", 39
"decorative", 40
"lcdfilter", 41
"namelang", 42
"fontfeatures", 43
"prgname", 44
"hash", 45
"postscriptname", 46
"color", 47
"symbol", 48
"fontvariations", 49
"variable", 50
//-TELESCOPE_LIB_CHANGES