/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_AUTHN)

#include "JSAttestationConveyancePreference.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(AttestationConveyancePreference enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("none"),
        MAKE_STATIC_STRING_IMPL("indirect"),
        MAKE_STATIC_STRING_IMPL("direct"),
    };
    static_assert(static_cast<size_t>(AttestationConveyancePreference::None) == 0, "AttestationConveyancePreference::None is not 0 as expected");
    static_assert(static_cast<size_t>(AttestationConveyancePreference::Indirect) == 1, "AttestationConveyancePreference::Indirect is not 1 as expected");
    static_assert(static_cast<size_t>(AttestationConveyancePreference::Direct) == 2, "AttestationConveyancePreference::Direct is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, AttestationConveyancePreference enumerationValue)
{
    return jsStringWithCache(&lexicalGlobalObject, convertEnumerationToString(enumerationValue));
}

template<> Optional<AttestationConveyancePreference> parseEnumeration<AttestationConveyancePreference>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    if (stringValue == "none")
        return AttestationConveyancePreference::None;
    if (stringValue == "indirect")
        return AttestationConveyancePreference::Indirect;
    if (stringValue == "direct")
        return AttestationConveyancePreference::Direct;
    return WTF::nullopt;
}

template<> const char* expectedEnumerationValues<AttestationConveyancePreference>()
{
    return "\"none\", \"indirect\", \"direct\"";
}

} // namespace WebCore

#endif // ENABLE(WEB_AUTHN)
