/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM)

#include "JSLongRange.h"

#include "JSDOMConvertNumbers.h"
#include "JSDOMGlobalObject.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

#if ENABLE(MEDIA_STREAM)

template<> LongRange convertDictionary<LongRange>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    LongRange result;
    JSValue maxValue;
    if (isNullOrUndefined)
        maxValue = jsUndefined();
    else {
        maxValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "max"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!maxValue.isUndefined()) {
        result.max = convert<IDLLong>(lexicalGlobalObject, maxValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue minValue;
    if (isNullOrUndefined)
        minValue = jsUndefined();
    else {
        minValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "min"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!minValue.isUndefined()) {
        result.min = convert<IDLLong>(lexicalGlobalObject, minValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject& lexicalGlobalObject, JSDOMGlobalObject& globalObject, const LongRange& dictionary)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);

    auto result = constructEmptyObject(&lexicalGlobalObject, globalObject.objectPrototype());

    if (!IDLLong::isNullValue(dictionary.max)) {
        auto maxValue = toJS<IDLLong>(IDLLong::extractValueFromNullable(dictionary.max));
        result->putDirect(vm, JSC::Identifier::fromString(vm, "max"), maxValue);
    }
    if (!IDLLong::isNullValue(dictionary.min)) {
        auto minValue = toJS<IDLLong>(IDLLong::extractValueFromNullable(dictionary.min));
        result->putDirect(vm, JSC::Identifier::fromString(vm, "min"), minValue);
    }
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(MEDIA_STREAM)
